<?php
/**
*
* @package empennage: Add code and content to the top/bottom of pages
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\empennage\acp;

class empennage_module
{
	protected $config;
	protected $phpbb_container;
	protected $config_text;
	protected $request;
	protected $template;
	protected $user;

	public	$u_action;

	function main($id, $mode)
	{
		global $cache, $config, $config_text, $db, $user, $auth, $template, $request;
		global $phpbb_root_path, $phpEx, $phpbb_admin_path, $phpbb_container;

		$this->config = $config;
		$this->config_text = $config_text;
		$this->request = $request;
		$this->template = $template;
		$this->user = $user;

		$this->page_title = 'ACP_EMPENNAGE';
		$this->tpl_name = 'acp_empennage';
		
		$submit = (isset($_POST['submit'])) ? true : false;
		$form_key = 'config_empennage';
		add_form_key($form_key);
		$error = array();
		
		$display_vars = array(
			'title'	=> 'ACP_EMPENNAGE',
			'vars'	=> array(
				'legend1'				=> 'ACP_EMPENNAGE_ADD_STYLESHEET_JS',
				'empennage_content_header_stylesheet_after_on'			=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_STYLESHEETS_AFTER_ON', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_header_stylesheet_after'				=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_STYLESHEETS_AFTER', 'validate' => 'text', 'type' => 'textarea:5:30', 'explain' => true),

				'legend2'				=> 'ACP_EMPENNAGE_ADD_ANNOUNCEMENT',
				'empennage_content_header_content_before_on'			=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_CONTENT_BEFORE_ON', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_header_content_before_for_bots'		=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_CONTENT_BEFORE_BOTS', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_header_content_before_for_guests'	=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_CONTENT_BEFORE_GUESTS', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_header_content_before_for_users'		=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_CONTENT_BEFORE_USERS', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_header_content_before_for_url_mask'	=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_CONTENT_BEFORE_URL_MASK', 'validate' => 'text', 'type' => 'textarea:1:30', 'explain' => true),
				'empennage_content_header_content_before'				=> array('lang' => 'ACP_EMPENNAGE_CONTENT_HEADER_CONTENT_BEFORE', 'validate' => 'text', 'type' => 'textarea:5:30', 'explain' => true),

				'legend3'				=> 'ACP_EMPENNAGE_ADD_COPYRIGHT',
				'empennage_content_copyright_append_on'					=> array('lang' => 'ACP_EMPENNAGE_CONTENT_COPYRIGHT_APPEND_ON', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_copyright_append'					=> array('lang' => 'ACP_EMPENNAGE_CONTENT_COPYRIGHT_APPEND', 'validate' => 'text', 'type' => 'textarea:5:30', 'explain' => true),

				'legend4'				=> 'ACP_EMPENNAGE_ADD_FOOTER',
				'empennage_content_footer_after_on'						=> array('lang' => 'ACP_EMPENNAGE_CONTENT_FOOTER_AFTER_ON', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_footer_after'						=> array('lang' => 'ACP_EMPENNAGE_CONTENT_FOOTER_AFTER', 'validate' => 'text', 'type' => 'textarea:5:30', 'explain' => true),

				'legend5'				=> 'ACP_EMPENNAGE_ADD_JS',
				'empennage_content_footer_body_after_on'				=> array('lang' => 'ACP_EMPENNAGE_CONTENT_FOOTER_BODY_AFTER_ON', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_content_footer_body_after'					=> array('lang' => 'ACP_EMPENNAGE_CONTENT_FOOTER_BODY_AFTER', 'validate' => 'text', 'type' => 'textarea:5:30', 'explain' => true),

				'legend6'				=> 'ACP_EMPENNAGE_MODES',
				'empennage_debug'										=> array('lang' => 'ACP_EMPENNAGE_DEBUG', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_allow_php'									=> array('lang' => 'ACP_EMPENNAGE_ALLOW_PHP', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_allow_tpldata'								=> array('lang' => 'ACP_EMPENNAGE_ALLOW_TPLDATA', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),

				'legend7'				=> 'ACP_EMPENNAGE_EDITOR',
				'empennage_codemirror'									=> array('lang' => 'ACP_EMPENNAGE_CODEMIRROR', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'empennage_cm_path'										=> array('lang' => 'ACP_EMPENNAGE_CM_PATH', 'validate' => 'string',	'type' => 'text:40:40', 'explain' => true),

				'legend8'				=> 'ACP_SUBMIT_CHANGES',
			),
		);
						
		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		if (!function_exists('display_custom_bbcodes'))
		{
			include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
		}

		if (!class_exists('parse_message'))
		{
			include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		}
		
		$config_text = $phpbb_container->get('config_text');

		$empennage_config_text_keys = array();
		$empennage_config_keys = array();

		foreach ( $display_vars['vars'] as $varname => $vararray )
		{
			if ( !is_array($vararray) ) continue;
			if ( $vararray['validate'] == 'text' )
			{
				$empennage_config_text_keys[] = $varname;
			}
			else
			{
				$empennage_config_keys[] = $varname;
			}
		}

		$empennage_config_text_values = array();
		foreach ( $empennage_config_text_keys as $key => $value)
		{
			$data = $config_text->get_array(array($value));
			$empennage_config_text_values[$value] = $data[$value];
		}

		$empennage_config_values = array();
		foreach ( $empennage_config_keys as $key => $value)
		{
			$empennage_config_values[$value] = $this->config[$value];
		}

		if (!sizeof($error) && $this->request->is_set_post('submit'))
		{
			if (!check_form_key($form_key))
			{
				$error[] = $user->lang('FORM_INVALID');
			}

			foreach ( $empennage_config_text_values as $key => $value)
			{
				$new_value = $request->variable(array('config',$key),'',true);
				if ( (string) $new_value !== (string) $value )
				{
					$value = $empennage_config_text_values[$key] = $new_value;
					$config_text->set_array(array(
						$key => $value,
					));
				}
			}

			foreach ( $empennage_config_values as $key => $value)
			{
				$new_value = $request->variable(array('config',$key),'',true);
				if ( (string) $new_value !== (string) $value )
				{
					$value = $empennage_config_values[$key] = $new_value;
					$config->set($key,$value);
				}
			}

			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		$new_config = array_merge($empennage_config_text_values,$empennage_config_values);

		$this->page_title = $display_vars['title'];
		
		$template->assign_vars(array(
			'L_TITLE'				=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'		=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
			'L_TITLE_DESCRIPTION'	=> $user->lang[$display_vars['title'] . '_DESCRIPTION'],

			'S_ERROR'			=> (sizeof($error)) ? true : false,
			'ERROR_MSG'			=> implode('<br />', $error),

			'S_EMPENNAGE_CODEMIRROR'	=> $empennage_config_values['empennage_codemirror'] ? true : false,
			'S_EMPENNAGE_CM_PATH'		=> $empennage_config_values['empennage_cm_path'],
		));
		
		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$l_description = (isset($user->lang[$vars['lang'] . '_DESCRIPTION'])) ? $user->lang[$vars['lang'] . '_DESCRIPTION'] : '';

			$content = build_cfg_template($type, $config_key, $new_config, $config_key, $vars);

			if (empty($content))
			{
				continue;
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'TITLE_DESCRIPTION'	=> $l_description,
				'CONTENT'		=> $content,
				)
			);

			unset($display_vars['vars'][$config_key]);
		}
	}
}

?>