<?php
/**
*
* @package empennage: Add content to page bottom
* @copyright (c) 2014 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\empennage\migrations\v0xx;

class empennage_v_0_0_1 extends \phpbb\db\migration\migration
{
	public function effectively_installed()
	{
		return isset($this->config['empennage_version']) && version_compare($this->config['empennage_version'], '0.0.1', '>=');
	}

	static public function depends_on()
	{
		return array(
			'\phpbb\db\migration\data\v310\dev'
		);
	}

	public function update_schema()
	{
		return array(
		);
	}

	public function revert_schema()
	{
		return array(
		);
	}

	public function update_data()
	{
		return array(
			// Add configs
			array('config.add', array('empennage_content_copyright_append', '')),
			array('config.add', array('empennage_content_footer_after', '')),

			// Current version
			array('config.add', array('empennage_version', '0.0.1')),

			// Add ACP modules
			array('module.add', array('acp', 'ACP_CAT_DOT_MODS', 'ACP_EMPENNAGE')),
			array('module.add', array('acp', 'ACP_EMPENNAGE', array(
					'module_basename'	=> '\c61\empennage\acp\empennage_module',
					'module_langname'	=> 'ACP_EMPENNAGE_EXPLAIN',
					'module_mode'		=> 'config_empennage',
					'module_auth'		=> 'acl_a_empennage',
			))),
			
			// Add permissions
			array('permission.add', array('a_empennage', true)),

			// Set permissions
			array('permission.permission_set', array('ROLE_ADMIN_FULL', 'a_empennage')),
		);
	}
}